<div class="page-wrapper">
    <div id="dashboard_content" class="page page-dashboard">
        <zeb-page-header
            page-title="$ctrl.currentTitle">
            <div class="page-title__wrapper _header-options" layout layout-align="center start">
                <zf-sub-header-options ng-if="!isPageLoading">
                    <div class="hide-phone">
                        <md-button class="md-icon-button"
                            ng-if="MODE !== 'WIDGET_PLACEMENT' && dashboard.widgets.length"
                            ng-click="showEmailDialog($event, dashboard);">
                            <i class="material-icons">
                                send
                            </i>
                            <md-tooltip md-direction="bottom">Send by email</md-tooltip>
                        </md-button>
                        <md-button class="md-icon-button hide-tablet"
                            ng-if="$ctrl.userHasAnyPermission(['reporting:widgets:update']) && isGridStackEvailableToEdit() && dashboard.widgets.length && dashboard.editable"
                            ng-click="startEditWidgets();">
                            <i class="material-icons">
                                dashboard
                            </i>
                            <md-tooltip md-direction="bottom">Widget placement</md-tooltip>
                        </md-button>
                        <md-button class="md-icon-button"
                            ng-if="$ctrl.userHasAnyPermission(['reporting:dashboards:update']) && MODE !== 'WIDGET_PLACEMENT' && dashboard.editable"
                            ng-click="showDashboardSettingsModal($event, dashboard, 'edit');">
                            <i class="material-icons">
                                edit
                            </i>
                            <md-tooltip md-direction="bottom">Edit</md-tooltip>
                        </md-button>
                    </div>
                </zf-sub-header-options>
                <zf-sub-header-button ng-if="dashboard.editable" class="hide-tablet">
                    <div ng-if="$ctrl.userHasAnyPermission(['reporting:widgets:update']) && MODE !== 'WIDGET_PLACEMENT'">
                        <button class="fixed-page-header__btn _dashboard zf-primary-button" ng-click="showWidgetWizardDialog($event, {model : '{}'}, dashboard);">
                            <md-icon class="material-icons">add</md-icon>
                            <span>New widget</span>
                        </button>
                    </div>
                    <div ng-if="MODE === 'WIDGET_PLACEMENT'">
                        <md-button id="discard" ng-click="resetGrid();">
                            Cancel
                        </md-button>
                        <md-button id="apply" class="md-primary md-raised" ng-click="updateWidgetsPosition()">
                            Apply
                        </md-button>
                    </div>
                </zf-sub-header-button>
            </div>
        </zeb-page-header>
        <empty-page-component ng-if="!dashboard.widgets.length && !isPageLoading" content="emptyContent"></empty-page-component>
        <div class="dashboard__widgets-wrapper" ng-if="dashboard.widgets.length">
            <input type="hidden" id="dashboard_title" value="{{dashboard.title}}" />
            <div gridstack
                class="grid-stack"
                options="gridstackOptions"
                style="margin-bottom: 20px">
                <div class="grid-stack-item show-on-hover"
                    data-gs-min-height="2"
                    data-gs-min-width="1"
                    ng-attr-id="widget-{{widget.id}}"
                    data-ng-repeat="widget in dashboard.widgets track by widget.id"
                    gridstack-item
                    gs-item-x="widget.location.x"
                    gs-item-y="widget.location.y"
                    gs-item-width="widget.location.width"
                    gs-item-height="widget.location.height">
                    <input type="hidden" ng-attr-id="widget-title-{{ widget.id }}" value="{{widget.title}}" />
                    <div ng-attr-id="widget-container-{{ widget.id }}" class="panel panel-default grid-stack-item-content" zafira-background-theme="graph" title={{widget.title}}>
                        <div class="panel-heading">
                            {{widget.title}}
                            <md-menu class="pull-right widget-icon hide-phone"
                                ng-if="$ctrl.userHasAnyPermission(['reporting:widgets:update', 'reporting:widgets:delete']) || widget.data.dataset.length"
                                data-html2canvas-ignore>
                                <md-button name="widgetMenu" aria-label="Widget settings" class="md-icon-button"
                                    data-ng-click="$mdMenu.open($event);">
                                    <md-icon class="material-icons">more_vert</md-icon>
                                </md-button>
                                <md-menu-content width="2">
                                    <md-menu-item data-ng-if="widget.data.dataset.length">
                                        <md-button name="sendEmail" data-ng-click="showEmailDialog($event, widget)">
                                            Send by email
                                        </md-button>
                                    </md-menu-item>
                                    <md-menu-item ng-if="$ctrl.userHasAnyPermission(['reporting:widgets:update']) && dashboard.editable">
                                        <md-button name="editWidget" data-ng-click="showNeededWidgetModal($event, widget, false, dashboard)">
                                            Edit widget
                                        </md-button>
                                    </md-menu-item>
                                    <md-menu-item ng-if="$ctrl.userHasAnyPermission(['reporting:widgets:delete']) && dashboard.editable">
                                        <md-button name="deleteWidget" data-ng-click="deleteDashboardWidget(widget)">
                                            Remove from dashboard
                                        </md-button>
                                    </md-menu-item>
                                </md-menu-content>
                            </md-menu>
                        </div>
                        <div ng-attr-id="widget-container-body-{{ widget.id }}"
                            align="center"
                            class="panel-body"
                            data-ng-class="{'graph-box' : (widget.type == 'linechart' || widget.type == 'piechart')}">
                            <md-progress-circular class = "progress-circular_align" md-mode="indeterminate" md-diameter="31px" ng-if="isLoading && widget.data.dataset !== 0"></md-progress-circular>
                            <linechart data-ng-if="widget.type == 'linechart' && widget.data.dataset !== 0" data="widget.data" options="widget.model"></linechart>
                            <div data-ng-if="widget.type == 'piechart'" class="pie-chart">
                                <pie-chart data="widget.data.dataset" options="widget.model"></pie-chart>
                            </div>
                            <div data-ng-if="ECHART_TYPES.indexOf(widget.type) !== -1 && widget.model" style="overflow: auto;">
                                <div data-echarts
                                    ng-if="widget.type !== 'TABLE' && widget.data.dataset.length"
                                    dataset="widget.data.dataset"
                                    with-legend="true"
                                    chart-actions="widget.chartActions"
                                    data-options="widget.model"></div>
                                <table ng-if="widget.type === 'TABLE' && widget.data.dataset != 0" data-ng-attr-id="table-{{ widget.id }}" class="table table-striped table-bordered table-hover" style="width: 100%;">
                                    <thead>
                                        <tr>
                                            <th class="pointer" ng-show="widget.builder.legendConfigObject[column] === undefined || widget.builder.legendConfigObject[column]" data-ng-repeat="column in widget.model.columns track by $index" data-ng-click="changeSorting(widget, column)">
                                                {{column}}&nbsp;<i class="fa fa-sort"></i>
                                            </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr ng-init="optimizeWidget(widget, rowIndex)" data-ng-repeat="(rowIndex, row) in widget.data.dataset | orderObjectBy:widget.sort.column:widget.sort.descending">
                                            <td ng-show="widget.builder.legendConfigObject[column] === undefined || widget.builder.legendConfigObject[column]" ng-switch="isFormatted(row[column]);" data-ng-repeat="column in widget.model.columns track by $index">
                                                <span ng-switch-when="true" data-ng-bind-html="asString(row[column])"></span>
                                                <span ng-switch-default>{{row[column]}}</span>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            <div data-ng-if="widget.type == 'table'" class="table-responsive">
                                <table  data-ng-attr-id="table-{{ widget.id }}" class="table table-striped table-bordered table-hover" style="width: 100%;">
                                    <thead>
                                        <tr>
                                            <th class="pointer" data-ng-repeat="column in widget.model.columns track by $index" data-ng-click="changeSorting(widget, column)">
                                                {{column}}&nbsp;<i class="fa fa-sort"></i>
                                            </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr ng-init="optimizeWidget(widget, rowIndex)" data-ng-repeat="(rowIndex, row) in widget.data.dataset | orderObjectBy:widget.sort.column:widget.sort.descending track by $index">
                                            <td ng-switch="isFormatted(row[column]);" data-ng-repeat="column in widget.model.columns track by $index">
                                                <span ng-switch-when="true" data-ng-bind-html="asString(row[column])"></span>
                                                <span ng-switch-default>{{row[column]}}</span>
                                            </td>
                                        </tr>
                                        <tr ng-init="optimizeWidget(widget)" class="text-center" data-ng-if="widget.data.dataset == 0">
                                            <td colspan="{{widget.model.columns.length}}">No data</td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                        <div class="dashboard__widgets-wrapper_widget-no-data" ng-if="widget.data.dataset == 0">
                            <div  class="dashboard__widgets-wrapper_widget-no-data_icon">
                                <md-icon md-svg-src="../../assets/images/chart_no_data.svg"></md-icon>
                            </div>
                            <div class="dashboard__widgets-wrapper_widget-no-data_text">
                                No chart to display
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
